
#ifndef __BREAKOUT_H_INCLUDED__
#define __BREAKOUT_H_INCLUDED__

#include "GpBaseClass.h"

const int	borderwidth=5;
const int	batwidth=20;
const int	ballsize=5;
const int	batheight=5;
const int	scoreheight=20;
const int	brickwidth=15;
const int       brickheight=8;
const int	brickspace=2;
const int	backcol=0x102040;
const int	numlines=4;
const int       startline=32;

class Breakout : public GpBaseClass
{ 
public:
  Breakout();
  ~Breakout();
protected:
  virtual void Paint();
  virtual void KeyUp(int key);
  virtual void KeyDown(int key);
private:
  bool		ingame;

  int		player1score;
  int		ballx,bally;
  int		batpos;
  int		batdpos;
  int		balldx, balldy;
  int		dxval;
  int		ballsleft;
  bool		*showbrick;
  int		bricksperline;
  int		width;

  void GameInit();
  void InitBricks();
  void PlayGame();
  void ShowIntroScreen();
  void DrawBricks();
  void DrawPlayField();
  void ShowScore();
  void MoveBall();
  void BatDummyMove();
  void CheckBat();
  int CheckBatBounce(int dy, int delta);
  void CheckBricks();
};

#endif
